package abc.ltl;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

import polyglot.ast.Node;
import polyglot.util.CodeWriter;
import polyglot.visit.PrettyPrinter;

/**
 * @author Eric Bodden
 *
 * Util
 */
public class Util {

    private final static PrettyPrinter pp;
    
    private final static CodeWriter cw;
    
    private final static ByteArrayOutputStream bos;
    
    static{
        pp = new PrettyPrinter();
        bos = new ByteArrayOutputStream();
        cw = new CodeWriter(bos,Integer.MAX_VALUE);
    }
    
    public static String nodeToString(Node n) {
        bos.reset();
        n.prettyPrint(cw,pp);
        try {
            cw.flush();
        } catch (IOException e) {
        }
        return bos.toString();
    }
    
}
