package abc.ltl.ast;

import java.util.Collection;

import polyglot.ast.Formal;
import polyglot.util.Position;
import rwth.i2.ltlrv.management.ByteCodePosition;
import abc.aspectj.ast.AJNodeFactory;
import abc.aspectj.ast.Pointcut;
import abc.meta.ast.MetaNodeFactory;


public interface LTLNodeFactory extends MetaNodeFactory {

    public PCFormula PCFormula(Collection<Formal> formals, PCLTLGeneral innerPc, ByteCodePosition pos);

    public PCLTLFinally PCLTLFinally(Position pos, Pointcut pc);
	
	public PCLTLGlobally PCLTLGlobally(Position pos, Pointcut pc);
	
    public PCLTLNext PCLTLNext(Position pos, Pointcut pc);

    public PCLTLUntil PCLTLUntil(Position pos, Pointcut pcl, Pointcut pcr);
	
    public PCLTLRelease PCLTLRelease(Position pos, Pointcut pcl, Pointcut pcr);
    
    public PCLTLAnd PCLTLAnd(Position pos, Pointcut pcl, Pointcut pcr);

    public PCLTLOr PCLTLOr(Position pos, Pointcut pcl, Pointcut pcr);

    public PCLTLImplies PCLTLImplies(Position pos, Pointcut pcl, Pointcut pcr);
    
    public PCLTLEquiv PCLTLEquiv(Position pos, Pointcut pcl, Pointcut pcr);
    
    public PCLTLNot PCLTLNot(Position pos, Pointcut pc);

    public ByteCodePosition ByteCodePosition(String className, String sourceFile, int lineNumber);
    
}
