package abc.ltl.ast;

import java.util.Collection;
import java.util.Map;

import polyglot.ast.ClassMember;
import polyglot.ast.Expr;
import polyglot.ast.Formal;
import polyglot.util.Position;
import rwth.i2.ltlrv.management.ByteCodePosition;
import abc.aspectj.ast.Pointcut;
import abc.ltl.visit.transform.PropositionLabels;

/**
 * @author Eric Bodden
 *
 * PCFormula_c
 */
public interface PCFormula extends Pointcut, ClassMember {

    public PCLTLGeneral getInnerPc();
    
    public ByteCodePosition getByteCodePosition();
    
    public Collection<Formal> getFormals();
    
    public Expr formulaConstructorExpr(PropositionLabels vis, Position pos);
    
    public void setPropositionIds(Map<Pointcut,Integer> propToId);
    
    /**
     * @param pc
     * @return
     */
    public String propositionLabel(Pointcut pc);
    
    public boolean isPrepareForMultiThreading();
    
}