package abc.ltl.ast;

import static abc.ltl.visit.transform.RuntimeRepresentation.*;
import polyglot.ast.Node;
import polyglot.util.Position;
import abc.weaving.aspectinfo.Pointcut;

public class PCLTLAnd_c extends PCLTLBinary_c implements PCLTLAnd {

    /**
     * @param pos
     * @param pcl
     * @param pcr
     */
    public PCLTLAnd_c(Position pos, abc.aspectj.ast.Pointcut pcl, abc.aspectj.ast.Pointcut pcr) {
        super(pos, pcl, pcr);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Node reconstruct(abc.aspectj.ast.Pointcut pcl, abc.aspectj.ast.Pointcut pcr) {
        if (pcl != this.pcl || pcr != this.pcr) {
            PCLTLAnd_c n = (PCLTLAnd_c) copy();
            n.pcl = pcl;
            n.pcr = pcr;
            return n;
        }
        return this;
    }

    /**
     * {@inheritDoc}
     */
    public Pointcut makeAIPointcut() {
        //TODO
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected String getSymbol() {
        return "&&";
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected String runtimeClassName() {
        return OP_AND_CLASS_NAME;
    }

}
