package abc.ltl.ast;

import java.util.List;

import polyglot.ast.Term;
import polyglot.util.CodeWriter;
import polyglot.util.Position;
import polyglot.visit.CFGBuilder;
import polyglot.visit.PrettyPrinter;
import abc.aspectj.ast.Pointcut_c;

public abstract class PCLTLGeneral_c extends Pointcut_c implements PCLTLGeneral {

    public PCLTLGeneral_c(Position pos) {
        super(pos);
    }

    /*
     * the following have to be implemented for the sake of compatibility with
     * the classmember interface
     */
    @SuppressWarnings("unused")
    public List acceptCFG(CFGBuilder v, List succs) {
        throw new UnsupportedOperationException(
                "Not supported for PCLTLGeneral_c");
    }

    public Term entry() {
        throw new UnsupportedOperationException(
                "Not supported for PCLTLGeneral_c");
    }

    public boolean reachable() {
        throw new UnsupportedOperationException(
                "Not supported for PCLTLGeneral_c");
    }

    @SuppressWarnings("unused")
    public Term reachable(boolean reachability) {
        throw new UnsupportedOperationException(
                "Not supported for PCLTLGeneral_c");
    }

    public abstract void prettyPrint(CodeWriter w, PrettyPrinter tr);

}
