package abc.ltl.ast;

import static abc.ltl.visit.transform.RuntimeRepresentation.*;
import polyglot.ast.Node;
import polyglot.util.Position;
import abc.weaving.aspectinfo.Pointcut;

public class PCLTLNext_c extends PCLTLUnary_c implements PCLTLNext {

    /**
     * @param pos
     * @param pc
     */
    public PCLTLNext_c(Position pos, abc.aspectj.ast.Pointcut pc) {
        super(pos, pc);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Node reconstruct(abc.aspectj.ast.Pointcut pc) {
        if (pc != this.pc) {
            PCLTLNext_c n = (PCLTLNext_c) copy();
            n.pc = pc;
            return n;
        }
        return this;
    }

    /**
     * {@inheritDoc}
     */
    public Pointcut makeAIPointcut() {
        //TODO
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected String getSymbol() {
        return "X";
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    protected String runtimeClassName() {
        return OP_X_CLASS_NAME;
    }

}
