package abc.ltl.ast;

import static abc.ltl.visit.transform.RuntimeRepresentation.*;
import polyglot.ast.Node;
import polyglot.util.Position;
import abc.aspectj.ast.Pointcut;

/**
 * @author Eric
 */
/**
 * PCLTLRelease_c
 * 
 * @author Eric Bodden
 */
public class PCLTLRelease_c extends PCLTLBinary_c implements PCLTLRelease
{
    public PCLTLRelease_c(Position pos, Pointcut pcl, Pointcut pcr)  {
		super(pos, pcl, pcr);
    }

    /** Reconstruct the pointcut. */
	protected Node reconstruct(Pointcut pcl, Pointcut pcr) {
		if (pcl != this.pcl || pcr != this.pcr) {
			PCLTLRelease_c n = (PCLTLRelease_c) copy();
			n.pcl = pcl;
			n.pcr = pcr;
			return n;
		}
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	public abc.weaving.aspectinfo.Pointcut makeAIPointcut() {
    	//TODO
    	return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected String getSymbol() {
        return "R";
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    protected String runtimeClassName() {
        return OP_R_CLASS_NAME;
    }
}
