package abc.ltl.ast.override;

import polyglot.ast.AmbTypeNode;
import polyglot.ast.Formal;
import polyglot.ast.Node;
import polyglot.ast.TypeNode;
import polyglot.util.Position;
import abc.aspectj.ast.AmbTypeOrLocal;
import abc.aspectj.ast.ArgPattern;
import abc.ltl.ast.PointcutUtils;

/**
 * Override to adhere to the StatebindingPointcut interface.
 * @see abc.ltl.ast.override.StatebindingPointcut
 * @author Eric Bodden
 */
public class PCThis_c extends abc.aspectj.ast.PCThis_c implements StatebindingPointcut {

    /**
     * @param pos
     * @param pat
     */
    public PCThis_c(Position pos, ArgPattern pat) {
        super(pos, pat);
    }
    
    /**
     * {@inheritDoc}
     */
    public Node[] patterns() {
        return new Node[] {pat};
    }

    /**
     * {@inheritDoc}
     */
    public Node replaceBindingsByTypes(Formal... declaredFormals) {
        if(!(pat instanceof AmbTypeOrLocal)) {
            throw new RuntimeException("internal error in PCThis_c [1]");
        }
        TypeNode type = ((AmbTypeOrLocal)pat).type();
        
        if(!(type instanceof AmbTypeNode)) {
            throw new RuntimeException("internal error in PCThis_c [2]");
        }
        AmbTypeNode amb = (AmbTypeNode) type;
        String name = amb.name();
        TypeNode boundType = PointcutUtils.bindingNameToType(name,declaredFormals);
        
        if(boundType==null) {
            //"name" has no bound type so "name" maybe *is* a type itself
            return this;
        } else {
            return reconstruct( (TypeNode)boundType.copy() );
        }
        
    }

}
