/*
 * Created on Mar 1, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package abc.ltl.visit.override;

import java.io.File;
import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;

import abc.ltl.formulaextraction.SyntheticSource;

import polyglot.ast.ClassDecl;
import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.ast.SourceFile;
import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;
import polyglot.visit.NodeVisitor;

public class CollectJimplifyVisitor extends
		abc.aspectj.visit.CollectJimplifyVisitor {

	public CollectJimplifyVisitor(Job job, TypeSystem ts, NodeFactory nf,
			Collection source_files, Map class_to_ast) {
		super(job, ts, nf, source_files, class_to_ast);
	}
	
	@Override
    @SuppressWarnings("unchecked")
    protected NodeVisitor enterCall(Node n) throws SemanticException {
	        if (n instanceof SourceFile) {
				if(!(((SourceFile)n).source() instanceof SyntheticSource)) {
		        	boolean found = false;
		        	File nfile = null;
		        	try {nfile = (new File(((SourceFile) n).source().path())).getCanonicalFile();
		        	} catch (IOException e) {}
		            for (
                            Iterator<String> it = source_files.iterator();
                            !found && it.hasNext();
                        ) {
                        String name = (String) it.next();
		            	File f = null;
		            	try {f = (new File(name)).getCanonicalFile();
		            	} catch (IOException e) {}
		            	found = (f.compareTo(nfile) == 0);
		            }
		            if (!found) {
		                throw new SemanticException("Source file was needed but not given on the commandline", n.position());
		            }
				}
		        current_ast = n;
	        }
	        if (n instanceof ClassDecl) {
	            String cname = ((ClassDecl)n).type().fullName();
	            //System.err.println("Collecting class "+cname);
	            class_to_ast.put(cname, current_ast);
	            return bypassChildren(n);
	        }
	        return this;
	    }

}
