package abc.ltl.visit.transform;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import polyglot.ast.ClassBody;
import polyglot.ast.ClassMember;
import polyglot.ast.Node;
import polyglot.util.TypedList;
import polyglot.visit.NodeVisitor;
import abc.ltl.ast.PCFormula;

public class CleanUp extends NodeVisitor {

    /**
     * {@inheritDoc}
     */
    @Override
    public Node leave(Node old, Node n, NodeVisitor v) {
        if(n instanceof ClassBody) {
            //fetch members
            @SuppressWarnings("unchecked")
            List<ClassMember> members = new LinkedList<ClassMember>(((ClassBody)n).members());
            //remove formula(e)
            for (Iterator<ClassMember> iter = members.iterator(); iter.hasNext();) {
                ClassMember element = (ClassMember) iter.next();
                if(element instanceof PCFormula) {
                    iter.remove();
                }
            }
            //set new body
            n = ((ClassBody)n).members( new TypedList(members, ClassMember.class, true) );
        }
        return super.leave(old, n, v);
    }
    
}
