package abc.ltl.visit.transform;

import static abc.ltl.visit.transform.RuntimeRepresentation.PACKAGE_IMPORTS;

import java.util.ArrayList;
import java.util.List;

import polyglot.ast.Import;
import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.ast.SourceFile;
import polyglot.util.TypedList;
import polyglot.visit.NodeVisitor;

public class ImportStatements extends NodeVisitor {

    private NodeFactory nf;
    
    /**
     * @param nf
     */
    public ImportStatements(NodeFactory nf) {
        this.nf = nf;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unchecked")
    public Node leave(Node old, Node n, NodeVisitor v) {
        if(n instanceof SourceFile) {
            SourceFile sf = (SourceFile)n;
            List<Import> imports = new ArrayList<Import>();
            imports.addAll(sf.imports());
            for (String packageImport : PACKAGE_IMPORTS) {
                imports.add(nf.Import(n.position(),Import.PACKAGE,packageImport));
            }
            n = sf.imports( new TypedList(imports, Import.class, true) );
        }
        return super.leave(old, n, v);
    }
    
}
